Skip to main content
`Ctrl`+`K`

# MatGetRowIJ

Returns the compressed row storage i and j indices for the local rows of a sparse matrix

## Synopsis

    #include "petscmat.h"
    PetscErrorCode MatGetRowIJ(Mat mat, PetscInt shift, PetscBool symmetric, PetscBool inodecompressed, PetscInt *n, const PetscInt *ia[], const PetscInt *ja[], PetscBool *done)

Collective

## Input Parameters

- mat - the matrix

- shift - 0 or 1 indicating we want the indices starting at 0 or 1

- symmetric - `PETSC_TRUE` or `PETSC_FALSE` indicating the matrix data structure should be symmetrized

- inodecompressed - `PETSC_TRUE` or `PETSC_FALSE` indicating if the nonzero structure of the inodes or the nonzero elements is wanted. For `MATBAIJ` matrices the compressed version is always used.

## Output Parameters

- n - number of local rows in the (possibly compressed) matrix, use `NULL` if not needed

- ia - the row pointers; that is ia[0] = 0, ia[row] = ia[row-1] + number of elements in that row of the matrix, use `NULL` if not needed

- ja - the column indices, use `NULL` if not needed

- done - indicates if the routine actually worked and returned appropriate ia[] and ja[] arrays; callers are responsible for handling the case when done == `PETSC_FALSE` and ia and ja are not set

## Notes

You CANNOT change any of the ia[] or ja[] values.

Use `MatRestoreRowIJ()` when you are finished accessing the ia[] and ja[] values.

## Fortran Notes

Use

        PetscInt, pointer :: ia(:),ja(:)
        call MatGetRowIJ(mat,shift,symmetric,inodecompressed,n,ia,ja,done,ierr)
        ! Access the ith and jth entries via ia(i) and ja(j)

## See Also

Matrices, `Mat`, `MATAIJ`, `MatGetColumnIJ()`, `MatRestoreRowIJ()`, `MatSeqAIJGetArray()`

## Level

developer

## Location

src/mat/interface/matrix.c

## Implementations

MatGetRowIJ_MPIAdj() in src/mat/impls/adj/mpi/mpiadj.c
MatGetRowIJ_MPIAIJ() in src/mat/impls/aij/mpi/mpiaij.c
MatGetRowIJ_SeqAIJ() in src/mat/impls/aij/seq/aij.c
MatGetRowIJ_SeqBAIJ() in src/mat/impls/baij/seq/baij.c
MatGetRowIJ_SeqSBAIJ() in src/mat/impls/sbaij/seq/sbaij.c

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages